public class Affine {
    private int key_a;
    private int key_b;

    public Affine(int key_a, int key_b) {
        this.key_a = key_a;
        this.key_b = key_b;

        if( ModArithmetic.gcd( key_a, 26 ) != 1 ) {
            throw new RuntimeException( "You must select the first portion a of your key (a,b) such that gcd(a,26)==1. You chose: "+key_a );
        }
    }

    public String encrypt(String plaintext) { 
        return shift(plaintext,true);
    }
    public String decrypt(String ciphertext) { 
        return shift(ciphertext,false);
    }
    public String shift(String message, boolean encrypt) {
        String message2 = "";

        message = message.toUpperCase();
        //message = message.replace(" ","");

        for( int j = 0; j < message.length(); j++ ) {
            char c, c2;
            int ix, ix2;
            c = message.charAt(j);
            if(c >='A' && c <= 'Z'){
                ix = (int)(c - 'A');

                if( encrypt ) { 
                    ix2 = (this.key_a * ix + this.key_b) % 26;
                } else {
                    int inv_a = ModArithmetic.inverseMod( this.key_a, 26 );
                    ix2 = ( inv_a * (ix - this.key_b + 26 ) )%26;
                    // add the +26 to ensure everything stays positive
                }

                c2 = (char)('A' + ix2);
                message2 += c2;
            } else if( c == ' ' ) {
                //message2 += " ";
            }
        }

        return message2;
    }

}
