
public class Rotors {
	public static void main(String[] args) {

        BigInteger combos = new BigInteger("1");
        BigInteger combos2 = new BigInteger("1");

        int N = 10; // number of switchboard wires
        int P = 5;  // number of possible rotors
        int Q = 5;  // number of possible reflectors
        int R = 3;  // number of rotors
        int S = 26; // number of symbols

		// Rotor wheel combinations
        for(int j=P; j>(P-R); j--) { 
            BigInteger next = BigInteger.valueOf(j);
            combos = combos.multiply(next);
        }

        // Rotor wheel notch positions (assume 1 per wheel). 
        // Ignore left-most wheel.
        for(int k=0; k<(R-1); k++ ) {
            BigInteger next = BigInteger.valueOf(S);
            combos = combos.multiply(next);
        }

        // Rotor wheel starting positions
        for(int k=0; k<R; k++ ) {
            BigInteger next = BigInteger.valueOf(S);
            combos = combos.multiply(next);
        }
        System.out.print("Rotor wheel combinations: ");
        System.out.println(formatter.format(combos));

        // The output at this point matches http://www.cryptomuseum.com/crypto/enigma/working.htm

        // Switchboard combinations
        // $$ C = \frac{ S! }{ N! (S-2N)! 2^N }
        BigInteger binomial = BigInteger.ONE;
        for(int j=S; j>(S-2*N); j--) {
            BigInteger next = BigInteger.valueOf(j);
            binomial = binomial.multiply(next);
        }
        BigInteger nfact = BigInteger.ONE;
        for(int i=1; i<=N; i++ ) {
            BigInteger next = BigInteger.valueOf(i);
            nfact = nfact.multiply(next);
        }
        BigInteger twopow = BigInteger.valueOf(2);
        twopow = twopow.pow(N);

        combos2 = combos2.multiply(binomial);
        combos2 = combos2.divide(nfact);
        combos2 = combos2.divide(twopow);

        System.out.print("Switchboard combinations: ");
        System.out.println(formatter.format(combos2));

        // The output at this point matches http://www.cryptomuseum.com/crypto/enigma/working.htm

        combos = combos.multiply(combos2);

        // Possible reflectors
        BigInteger q = BigInteger.valueOf(Q);
        combos = combos.multiply(q);

        System.out.print("Final number of combinations: ");
        System.out.println(formatter.format(combos));

