import java.util.*;

public class Chapter3 { 

    /** Run all problems from Chapter 3. */
    public static void main(String[] args) { 
        problem1();
        problem2();
        problem3();
        problem4();
        problem5();
        problem6();

        problem12();
        problem13();
        problem14();
    }

    public static void problem1() {

        // Problem 1
        // a) Find integers x and y such that 17x + 101y = 1
        int[] xy = new int[2];
        ModArithmetic.extendedEuclidian(xy, 17, 101);
        System.out.println("Problem 1a:");
        System.out.println("17x + 101y = 1");
        System.out.println("x = "+xy[0]);
        System.out.println("y = "+xy[1]);
        System.out.println("Check: 17 * "+xy[0]+" + 101 * "+xy[1]+" = "+(17*xy[0]+101*xy[1]) );
        System.out.println();

        // b) Find 17^-1 (mod 101)
        int inv = ModArithmetic.inverseMod(17,101);
        System.out.println("Problem 1b:");
        System.out.println("17^{-1} = "+inv+" (mod 101)");
        System.out.println("Check: 17 * "+inv+" = "+(17*inv)+" (mod 101) = "+(17*inv)%101+" (mod 101)");
        System.out.println();
    }

    public static void problem2() {

        // Problem 2
        // a) Solve 7d = 1 (mod 30)
        int inv7 = ModArithmetic.inverseMod(7,30);
        System.out.println("Problem 2a:");
        System.out.println("Solve 7d = 1 (mod 30)");
        System.out.println("d = "+inv7);
        System.out.println("Check: 7 * "+inv7+" = "+(7*inv7)+" (mod 30) = "+(7*inv7)%30+" (mod 30)");
        System.out.println();

        // b) Suppose you encode a message as a number m mod 31:
        //      m = 12
        int m = 12;
        int encrypted = ModArithmetic.exponentMod(m,7,31);
        int decrypted = ModArithmetic.exponentMod(encrypted,inv7,31);
        System.out.println("Problem 2b:");
        System.out.println("Testing encryption scheme.");
        System.out.println("Message: "+m);
        System.out.println("Encrypted Message: "+m+"^"+7+" (mod 31) = "+encrypted+" (mod 31)");
        System.out.println("Decrypted Message: "+encrypted+"^"+inv7+" (mod 31) = "+decrypted+" (mod 31)");
        System.out.println("For (mod p), exponents are (mod p-1), so invert 7 by multiplying by 1/7 mod 30 (from part a)");
        System.out.println();
    }

    public static void problem3() {

        // Problem 3
        // a) Find all solutions of 12x = 28 (mod 236)
        // b) Find all solutions of 12x = 30 (mod 236)
        ArrayList<Integer> result;

        System.out.println("Problem 3a:");
        System.out.println("Find solutions to 12x = 28 (mod 236).");
        try { 
            result = ModArithmetic.solve(12,28,236);
            System.out.println(result);
        } catch (RuntimeException e) {
            System.out.println("No inverse exists.");
        }
        // TODO: check
        System.out.println();

        System.out.println("Problem 3b:");
        System.out.println("Find solutions to 12x = 30 (mod 236).");
        try { 
            result = ModArithmetic.solve(12,30,236);
            System.out.println(result);
        } catch (RuntimeException e) {
            System.out.println("No inverse exists.");
        }
        // TODO: check
        System.out.println();
    }

    public static void problem4() { 

        // Problem 4
        int g4 = ModArithmetic.gcd(30030,257);

        System.out.println("Problem 4a:");
        System.out.println("gcd(30030,257) = "+g4);
        System.out.println();

        System.out.println("Problem 4b");
        System.out.println("Fact 1: 30030 and 257 are relatively prime.");
        System.out.println("Fact 2: 30030 = 2*3*5*7*11*13 (so none of these factor 257)");
        System.out.println("Fact 3: 13 is the largest prime smaller than sqrt(257).");
        System.out.println("Therefore, 257 is prime.");
        System.out.println();
    }

    public static void problem5() { 

        // Problem 5 gcd
        int gcd;
        gcd = ModArithmetic.gcd(4883, 4369);
        System.out.println("Problem 5a:");
        System.out.println("Compute gcd(4883, 4369)");
        System.out.println( gcd );
        // TODO: check
        System.out.println();

        ArrayList<Integer> primes;
        int n1, n2;
        System.out.println("Problem 5b:");
        System.out.println("Factor 4883 and 4369 into products of primes.");
        n1 = 4883; n2 = 4369;
        System.out.println(n1+":");
        System.out.println("Factor 1: "+gcd);
        System.out.println("Factor 2: "+(n1/gcd));
        System.out.println(n2+":");
        System.out.println("Factor 1: "+gcd);
        System.out.println("Factor 2: "+(n2/gcd));
        System.out.println();

    }

    public static void problem6() {

        // Problem 6 Fibonacci gcds
        // Compute gcd(F_n, F_{n-1}) for all n>=1
        int n = 15;
        ArrayList<Integer> fib = ModArithmetic.fibonacci(n);
        System.out.println("Problem 6a:");
        System.out.println("Compute gcd(F_{n}, F_{n-1}) for all n>=1.");
        for( int i = 1; i < fib.size(); i++ ) {
            int g = ModArithmetic.gcd( fib.get(i), fib.get(i-1) );
            System.out.println("The gcd of Fibonacci numbers F_"+(i)+" and F_"+(i-1)+" is gcd("+fib.get(i)+","+fib.get(i-1)+") = "+g);
        }
        System.out.println();

        int g6 = ModArithmetic.gcd(11111111,11111);
        System.out.println("Problem 6b:");
        System.out.println("gcd(11111111,11111) = "+g6);
        System.out.println();

    }


    
    public static void problem12() {
        int rem = ModArithmetic.exponentModPrime(2,10203,101);
        System.out.println("Problem 12:");
        System.out.println("Divide 2^10203 by 101. What is the remainder?");
        System.out.println(rem);
        System.out.println();
    }

    public static void problem13() {
        int rem = ModArithmetic.exponentModPrime(123,562,100);
        System.out.println("Problem 13:");
        System.out.println("Find the last 2 digits of 123^562.");
        System.out.println(rem);
        System.out.println();
    }

    public static void problem14() {
        System.out.println("Problem 14a:");
        System.out.println("Evaluate 7^7 (mod 4).");
        int sq7 = ModArithmetic.exponentMod(7,7,4);
        System.out.println(sq7);
        System.out.println();

        System.out.println("Problem 14b:");
        System.out.println("Use this result to find last digit of 7^7^7.");
        // 7^7^7 mod 10 => 7^7^7 mod 5 and 7^7^7 mod 2
        // simplifying,
        // 7^7^7 mod 2 = 7^{ 7^7 mod 1 } mod 2 = 7 mod 2 = 1 mod 2
        // 7^7^7 mod 5 = 7^{ 7^7 mod 4 } mod 5 = 7^{3} mod 5 = 3 mod 5
        // Now recombine these by listing all numbers i mod 10,
        // and looking for one that is 1 mod 2 and 3 mod 5
        int result_iter = 0;
        for(int i=1; i<=10; i++) {
            int m2 = (i%2);
            int m5 = (i%5);
            if(m2==1 && m5==3) {
                result_iter = i;
                break;
            }
        }
        System.out.println("Found answer: 7^7^7 mod 10 = "+result_iter);
    }





}
