public class Caesar{
    private int key;

    public Caesar(int key) {
        this.key = key;
    }

    public String shift(String message, 
                        boolean doEncryption, 
                        boolean spaces, 
                        boolean punctuation) {

        String message2 = "";

        message = message.toUpperCase();
        if(!spaces) { 
            message = message.replace(" ","");
        }
        if(!punctuation) {
            message = message.replaceAll("['!-+.^:,]",""); 
        }

        for( int j = 0; j < message.length(); j++ ) {
            char c, c2;
            int ix, ix2;
            c = message.charAt(j);

            // Deal with non-letter characters using user-specified strategy

            if( c >= 'A' && c <= 'Z' ) {
                // Apply Caesar shift to letters
                ix = (int)(c - 'A');

                if( doEncryption ) {
                    ix2 = (ix + this.key)%26;
                } else {
                    // have to add 26 to ensure everything positive, because -1 mod 26 does not become 25
                    ix2 = (26 + ix - this.key)%26;
                }

                c2 = (char)('A' + ix2);

                // append to message
                message2 += c2;

            } else {
                c2 = c;
                // append to message
                message2 += c2;
            }
        }

        return message2;
    }




    /** Encrypt in "easy mode", meaning you keep punctuation and spaces. IORU IORUE ORI ODKFJJG. */
    public String encryptEasy(String message) {
        // keep punctuation and spaces
        return shift(message,true,true,true);
    }

    /** Encrypt in "hard mode", meaning you strip all spaces and punctuation. OUIUEWROHIFGUHIWUE */
    public String encryptHard(String message) {
        return shift(message,true,false,false);
    }

    /** Encrypt, and explicitly set whether to remove punctuation and spaces. */ 
    public String encrypt( String message, boolean spaces, boolean punctuation ) {
        return shift(message,true,spaces,punctuation);
    }

    /** Decrypt */ 
    public String decrypt(String message) {
        return shift(message,false,true,true);
    }

    /** Decrypt with specified key */ 
    public String decrypt(String message, int k) {
        setKey(k);
        return shift(message,false,true,true);
    }

    public void setKey(int k) { 
        this.key = k;
    }

}

