public class OTP {

    public OTP() {}

    public String encrypt(String pad, String plaintext) {

        assert (pad.length() < plaintext.length());

        String new_message = "";

        String message = plaintext;
        String message_pad = pad;

        // automatically ignore spaces and punctuation
        message = message.toUpperCase();
        message = message.replace(" ","");
        message = message.replaceAll("['?!-+.^:;,]",""); 

        message_pad = message_pad.toUpperCase();
        message_pad = message_pad.replace(" ","");
        message_pad = message_pad.replaceAll("['?!-+.^:;,]",""); 
        

        for( int i = 0; i < message.length(); i++ ) { 
            char msg_c, pad_c, new_c;
            int msg_ix, pad_ix, new_ix;

            msg_c = message.charAt(i);
            pad_c = message_pad.charAt(i);

            assert ( msg_c >= 'A' && msg_c <= 'Z' );
            assert ( pad_c >= 'A' && pad_c <= 'Z' );

            // get index of current letter
            msg_ix = (int)( msg_c - 'A');
            //System.out.println("Current msg index: "+msg_ix);

            // get letter shift from pad (and add 1, for humans, A = 1 not 0)
            pad_ix = (int)( pad_c - 'A') + 1;
            //System.out.println("Current pad index: "+msg_ix);

            // shift
            new_ix = (msg_ix + pad_ix )%26;
            //System.out.println("New shift: "+msg_ix);

            // switch to char
            new_c = (char)('A' + new_ix);
            //System.out.println("New char: "+new_c);

            new_message += new_c;
        }


        
        System.out.println("Plaintext:");
        System.out.println(message);
        System.out.println();
        System.out.println("Pad:");
        System.out.println(message_pad);
        System.out.println();
        System.out.println("Cryptotext:");
        System.out.println(new_message);
        System.out.println();


        
        return new_message;
    }
}

